/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2024-2025 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to
 *  deal in the Software without restriction, including without limitation the
 *  rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 *  sell copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 *  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 *  IN THE SOFTWARE.
 *
 **********************************************************************************************************************/

// NOTE: Assertions have been autogenerated by tool/update_llpc_test_checks.py
// RUN: amdllpc -emit-lgc -gfxip 10.3 -o - %s | FileCheck -check-prefix=SHADERTEST %s

#version 450

#extension GL_AMD_gpu_shader_half_float: enable

layout(binding = 0, std430) buffer Buffers
{
    vec4 fv4;
};

layout(location = 0) out vec3 fragColor;

void main()
{
    f16vec2 f16v2_0 = f16vec2(fv4.xy);
    f16vec2 f16v2_1 = f16vec2(fv4.zw);

    bool b = false;
    bvec2 bv2 = equal(f16v2_0, f16v2_1);
    b = b || bv2.x;

    bv2 = notEqual(f16v2_0, f16v2_1);
    b = b || bv2.x;

    bv2 = lessThan(f16v2_0, f16v2_1);
    b = b && bv2.x;

    bv2 = greaterThan(f16v2_0, f16v2_1);
    b = b || bv2.x;

    bv2 = lessThanEqual(f16v2_0, f16v2_1);
    b = b && bv2.x;

    bv2 = greaterThanEqual(f16v2_0, f16v2_1);
    b = b || bv2.x;

    fragColor = b ? vec3(1.0) : vec3(0.0);
}

// SHADERTEST-LABEL: @lgc.shader.FS.main(
// SHADERTEST-NEXT:  .entry:
// SHADERTEST-NEXT:    [[TMP0:%.*]] = call ptr addrspace(7) @lgc.load.buffer.desc(i64 0, i32 0, i32 0, i32 2)
// SHADERTEST-NEXT:    [[TMP1:%.*]] = call ptr @llvm.invariant.start.p7(i64 -1, ptr addrspace(7) [[TMP0]])
// SHADERTEST-NEXT:    [[TMP2:%.*]] = load <4 x float>, ptr addrspace(7) [[TMP0]], align 16
// SHADERTEST-NEXT:    [[TMP3:%.*]] = shufflevector <4 x float> [[TMP2]], <4 x float> poison, <2 x i32> <i32 0, i32 poison>
// SHADERTEST-NEXT:    [[TMP4:%.*]] = fptrunc <2 x float> [[TMP3]] to <2 x half>
// SHADERTEST-NEXT:    [[TMP5:%.*]] = shufflevector <4 x float> [[TMP2]], <4 x float> poison, <2 x i32> <i32 2, i32 poison>
// SHADERTEST-NEXT:    [[TMP6:%.*]] = fptrunc <2 x float> [[TMP5]] to <2 x half>
// SHADERTEST-NEXT:    [[TMP7:%.*]] = extractelement <2 x half> [[TMP4]], i64 0
// SHADERTEST-NEXT:    [[TMP8:%.*]] = extractelement <2 x half> [[TMP6]], i64 0
// SHADERTEST-NEXT:    [[TMP9:%.*]] = fcmp oeq half [[TMP7]], [[TMP8]]
// SHADERTEST-NEXT:    [[TMP10:%.*]] = fcmp une half [[TMP7]], [[TMP8]]
// SHADERTEST-NEXT:    [[TMP11:%.*]] = or i1 [[TMP9]], [[TMP10]]
// SHADERTEST-NEXT:    [[TMP12:%.*]] = fcmp olt half [[TMP7]], [[TMP8]]
// SHADERTEST-NEXT:    [[TMP13:%.*]] = and i1 [[TMP11]], [[TMP12]]
// SHADERTEST-NEXT:    [[TMP14:%.*]] = fcmp ogt half [[TMP7]], [[TMP8]]
// SHADERTEST-NEXT:    [[TMP15:%.*]] = or i1 [[TMP13]], [[TMP14]]
// SHADERTEST-NEXT:    [[TMP16:%.*]] = fcmp ole half [[TMP7]], [[TMP8]]
// SHADERTEST-NEXT:    [[TMP17:%.*]] = and i1 [[TMP15]], [[TMP16]]
// SHADERTEST-NEXT:    [[TMP18:%.*]] = fcmp oge half [[TMP7]], [[TMP8]]
// SHADERTEST-NEXT:    [[TMP19:%.*]] = or i1 [[TMP17]], [[TMP18]]
// SHADERTEST-NEXT:    [[TMP20:%.*]] = select reassoc nnan nsz arcp contract afn i1 [[TMP19]], <3 x float> {{(splat \(float 1\.000000e\+00\))|(<float 1\.000000e\+00, float 1\.000000e\+00, float 1\.000000e\+00>)}}, <3 x float> zeroinitializer
// SHADERTEST-NEXT:    call void (...) @lgc.create.write.generic.output(<3 x float> [[TMP20]], i32 0, i32 0, i32 0, i32 0, i32 0, i32 poison)
// SHADERTEST-NEXT:    ret void
//
